<template>
  <v-dialog v-model="dialog" max-width="650">
    <template v-slot:activator="{ on }">
      <v-btn
        :disabled="user && user.role === 'facilitator'"
        color="red lighten-2"
        outlined
        dark
        v-on="on"
        >Join this circle</v-btn
      >
    </template>

    <v-card>
      <v-card-text v-if="!user" class="text-center pa-4">
        <p class="title">Please login to your account</p>
        <v-tabs grow v-model="authTab">
          <v-tab>Sign up</v-tab>
          <v-tab>Login</v-tab>
        </v-tabs>
        <v-tabs-items v-model="authTab">
          <v-tab-item>
            <signup-form />
          </v-tab-item>
          <v-tab-item>
            <login-form />
          </v-tab-item>
        </v-tabs-items>
      </v-card-text>

      <v-card-text v-if="user && !book && !enterCard" class="pa-4 text-center">
        <p class="display-1">Review your circle details</p>
        <h1 class="title mb-2">{{ circle.title | capitalize }}</h1>
        <p>With</p>
        <v-avatar color="indigo" size="36">
          <v-img
            class="elevation-6"
            :src="circle.facilitator && circle.facilitator.imageUrl"
          ></v-img>
        </v-avatar>
        <p class="pt-2">{{ circle.facilitator.firstName }}</p>
        <p class="subtitle-1">
          {{ circle.dateItem.date | moment('MM/DD/YY') }}
        </p>
        <p class="subtitle-1">
          The circle will start at
          {{ circle.dateItem.time }}
        </p>
        <v-row justify="center">
          <v-col xs="12" md="8">
            <v-divider class="my-2"></v-divider>
          </v-col>
        </v-row>
        <v-row>
          <v-col md="6" class="">
            <span class="subtitle-1 font-weight-medium">Total</span>
          </v-col>
          <v-col md="6">
            <span class="subtitle-1 font-weight-medium"
              >${{ circle.price }}</span
            >
          </v-col>
        </v-row>
        <v-row justify="center" class="mt-5">
          <v-col md="8" class="">
            <v-btn
              :disabled="disableBook || loading"
              outlined
              block
              @click="bookCircle"
              :loading="bookLoading"
              >{{ bookButtonName }}</v-btn
            >
          </v-col>
        </v-row>
      </v-card-text>
      <v-card-text v-if="user && bookFinish" class="pa-10 text-center">
        <p class="title">Your reservation is booked and confirmed</p>
        <v-btn outlined @click="dialog = false">Finish</v-btn>
      </v-card-text>
      <v-card-text v-if="user && errorHappened" class="pa-10 text-center">
        <p class="title">A booking error occurred.</p>
        <p v-if="bookError" class="subtitle-1">{{ bookError }}</p>
        <v-btn outlined @click="dialog = false">Go back</v-btn>
      </v-card-text>
      <v-card-text v-if="user && enterCard" class="pt-10 text-center">
        <p class="title">Please enter you credit card details.</p>
        <Stripe
          :show-coupon="false"
          :button-label="'Proceed'"
          :payment-type="'bookCircle'"
        />
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
import { mapState } from 'vuex'
import Stripe from '@/components/Shared/Payment/index'
import SignupForm from '@/components/Shared/Auth/Signup'
import LoginForm from '@/components/Shared/Auth/Login'
import EventBus from '@/event-bus'

export default {
  components: {
    Stripe,
    SignupForm,
    LoginForm
  },
  props: {
    circle: Object
  },
  data: () => ({
    authTab: 'login',
    dialog: false,
    book: false,
    bookButtonName: 'Book Circle',
    disableBook: false,
    bookFinish: false,
    loading: false,
    errorHappened: false,
    bookError: null,
    bookLoading: false,
    enterCard: false
  }),
  computed: {
    ...mapState('authentication', ['user'])
  },
  watch: {
    dialog: {
      handler(dialog) {
        if (dialog && this.user) {
          // this.$router.push('/login')
          this.loading = true
          this.$store
            .dispatch('circle/checkBookedCircle', this.circle.id)
            .then(snapshot => {
              this.loading = false
              const circle = snapshot.data()
              if (
                circle.facilitator.users &&
                circle.facilitator.users.length > 0
              ) {
                circle.facilitator.users.forEach(data => {
                  if (data === this.$store.state.authentication.user.id) {
                    this.disableBook = true
                    this.bookButtonName = 'Circle has already been booked.'
                  }
                })
              }
            })
            .catch(err => {
              this.loading = false
              console.log(err)
            })
        }
      },
      immediate: true
    }
  },
  created() {
    EventBus.$on('callBookCircle', cardAdded => {
      if (cardAdded === true) {
        this.bookCircle()
      }
    })
  },
  mounted() {
    this.$nextTick(() => {})
  },
  methods: {
    bookCircle() {
      this.book = false
      if (!this.disableBook && this.user.card) {
        this.enterCard = false
        this.bookLoading = true
        this.$store
          .dispatch('circle/addCircleToUser', this.circle.id)
          .then(res => {
            this.bookLoading = false
            this.book = !this.book
            if (res.data && res.data.status) {
              this.bookFinish = true
            } else {
              this.errorHappened = true
              this.bookError =
                res.data && res.data.message ? res.data.message : null
            }
          })
          .catch(err => {
            this.errorHappened = true
            this.bookLoading = false
            this.bookFinish = false
            this.errorHappened = true
            this.bookError = err.message ? err.message : null
          })
      } else {
        this.enterCard = true
      }
    }
  }
}
</script>

<style lang="scss" scoped></style>
